void draw() 
{
  //Maintains a consitent FrameRate as to much in the draw will lag the frame rate, since it maintaints the same speed between draws()
  //  regardless of how long the draw() takes so FPS drops when doing intensive draw() functions
  if (frameRate < Matrix.softwareFrameRate) frameRate(Matrix.softwareFrameRate+10);
  else frameRate(Matrix.softwareFrameRate);


 //scales display of buttons and other objects on screen to user selected size
 //  since just the display is scaled and not the objects, mouseX and mouseY events must be scaled to match
  scale(SF,SF);

  if (UpdateWorkspace == true)
  {
    //Only update the whole workspace when necassary, it does cause a slight delay
    println("Workspace Updated"); 
    UpdateWorkspace = false; 
    background(cBackgroundColor);
    for (int i=0; i != FeedAButtons.length;i++)  FeedAButtons[i].display();
    for (int i=0; i != FeedBButtons.length;i++)  FeedBButtons[i].display();   

    if (FeedAQuickPage == 0) for (int i=0; i != 15;i++)  QuickAButtons[i].displaySq(i);
    else if (FeedAQuickPage == 1)for (int i=15; i != 30;i++)  QuickAButtons[i].displaySq(i);
    else if (FeedAQuickPage == 2)for (int i=30; i != 45;i++)  QuickAButtons[i].displaySq(i);   
    else if (FeedAQuickPage == 3)for (int i=45; i != 60;i++)  QuickAButtons[i].displaySq(i); 

    if (FeedBQuickPage == 0) for (int i=0; i != 15;i++)  QuickBButtons[i].displaySq(i);
    else if (FeedBQuickPage == 1)for (int i=15; i != 30;i++)  QuickBButtons[i].displaySq(i);
    else if (FeedBQuickPage == 2)for (int i=30; i != 45;i++)  QuickBButtons[i].displaySq(i);   
    else if (FeedBQuickPage == 3)for (int i=45; i != 60;i++)  QuickBButtons[i].displaySq(i); 

    for (int i=0; i != CommonButtons.length;i++)  CommonButtons[i].display();
    for (int i=0; i != BlendButtons.length;i++)  BlendButtons[i].display();    
    MainMixerSlider.display();
    IntensitySliderA.display();
    IntensitySliderB.display();

    for (int i=0; i != CommonSliders.length;i++)  CommonSliders[i].display();   

    textSize(16);
    fill(0);
    text("Red:", CommonSliders[0].xpos-35, CommonSliders[0].ypos+CommonSliders[0].slHeight);
    text("Green:", CommonSliders[1].xpos-55, CommonSliders[1].ypos+CommonSliders[1].slHeight);  
    text("Blue:", CommonSliders[2].xpos-40, CommonSliders[2].ypos+CommonSliders[2].slHeight);

    text("Red:", CommonSliders[3].xpos-35, CommonSliders[3].ypos+CommonSliders[3].slHeight);
    text("Green:", CommonSliders[4].xpos-55, CommonSliders[4].ypos+CommonSliders[4].slHeight);  
    text("Blue:", CommonSliders[5].xpos-40, CommonSliders[5].ypos+CommonSliders[5].slHeight);

    textSize(14);    
    text("Speed:"+QuickFeeds[FeedASelQuick].Speed, CommonSliders[6].xpos-75, CommonSliders[6].ypos+CommonSliders[6].slHeight);
    text("Speed:"+QuickFeeds[FeedBSelQuick].Speed, CommonSliders[7].xpos-75, CommonSliders[7].ypos+CommonSliders[7].slHeight);

    text("Contrast:", CommonSliders[8].xpos, CommonSliders[8].ypos-CommonSliders[8].slHeight/3);
    text("Contrast:", CommonSliders[9].xpos, CommonSliders[9].ypos-CommonSliders[9].slHeight/3);
  } //end updateworkspace if()

  //============== DISPLAYS CONSTANTLY UPDATED USEFUL INFORMATION TO THE WORKSPACE ======================


  noStroke();
  fill(200, 200, 200);
  rect(275, 575, 265, 55); //draw a rect over the area to be redrawn

  if (TransmissionStatusCounter == 0)   fill(255, 0, 0); //toggles the indicator circle between green and red
  else if (TransmissionStatusCounter < 10)  fill(0, 255, 0);
  else fill(0, 0, 0);

  stroke(255, 255, 255);
  strokeWeight(1);
  ellipse(520, 585, 10, 10);
  if (TransmissionStatusCounter > 20) TransmissionStatusCounter = 0;

  textSize(14);
  fill(0);
  text("Connection: "+portName, 270, 590);
  text("Transmitting:", 420, 590);
  noStroke();

  
  //================ SERIAL CONTROL POLLING HANDLER ======================

  if (CommunicationConnected == true && Matrix.softwareSerialConEnable == true)
  {
    //if DMXSerial Control Is Enabled, Toggle DTR to request new packet
    if (DTRState == true) 
    {
      DTRState = false;
      myPort.setDTR(false);
    }
    else
    {
      DTRState = true;
      myPort.setDTR(true);
    }
    if (HandleSerialFlag == true) HandleSerialCmd();
  } 

  //=================HANDLE AUTOMATIC MODE - Mixes between feeds using data in the TXT file =================================

  if (AutoSequenceRunning == true)
  {
    DrawCount--;
    if (DrawCount == 0 && AutomaticMode == true) TransitionFlag = true;  //start blending every draw 

    if (TransitionFlag == true)
    {
      //blending convert BlendSpeed to float and add it to mixer value

        //  println("BlendSpeed="+(float)BlendSpeed / 1000);

      if (FeedID == true)  MixerValue = MixerValue - ((float)BlendSpeed / 1000);
      else MixerValue = MixerValue + ((float)BlendSpeed / 1000);

      // println("MixerValue="+MixerValue+" : "+FeedID);

      MainMixerSlider.Value = int(MixerValue * 100);
      MainMixerSlider.display();  

      if (AutomaticMode == true)
      {
        if (MixerValue >= 1 && FeedID == false)
        {
          MixerValue = 1;
          //  MainMixerSlider.Value = int(MixerValue * 100);
          //MainMixerSlider.display();   
          TransitionFlag = false; //reset flag
          AutoLines++; //increment auto line variable
          //load next auto line
          LoadAutoFile();
        }
        if (MixerValue <= 0 && FeedID == true)
        {
          MixerValue = 0; //was 1 and it was working, works just hte same with 0
          // MainMixerSlider.Value = int(MixerValue * 100);
          //MainMixerSlider.display();   
          TransitionFlag = false; //reset flag
          AutoLines++; //increment auto line variable
          //load next auto line
          LoadAutoFile();
        }
      } //end automatic mode if
      else
      {
        //just doing auto fade
        if (MixerValue >= 1 && FeedID == false)
        {
          MixerValue = 1;
          TransitionFlag = false; //reset flag
          AutoSequenceRunning = false;
        }
        if (MixerValue <= 0 && FeedID == true)
        {
          MixerValue = 0;
          TransitionFlag = false; //reset flag
          AutoSequenceRunning = false;
        }
      }//end else
    }
  }//end AutoSequenceRunning if()

  //===================== HANDLE SLIDERS N SUCH =======================================================================

  GUIMenus[OpenMenuID].display(); //display open menu if there is

  if (GlobalDragging == true)
  {
  HandleSliders(true);//true means to use mouse as move info
  }//end globaldragging if

  //=========================== These functions make it happen, Pack the Patched Pixels into the buffer arrays and Mix/Blend/Effects them ==========================================

  PackPixels(myMovieA, QuickFeeds[FeedASelQuick]); //put Feed A into its organized/patched buffer array
  PackPixels(myMovieB, QuickFeeds[FeedBSelQuick]); //put Feed B into its organized/patched buffer array
  MixFeeds(); //mix A and B

  //=========================== Run Each Feed Generating Functions ==========================================

  if (FeedAGenerating == true && QuickFeeds[FeedASelQuick].ControlState == 0) 
  {
    float TempSpeed = QuickFeeds[FeedASelQuick].Speed;
    ReverseFlag = false;

    if (TempSpeed < 0) 
    {
      ReverseFlag = true; //set flag to indicate reverse order
      TempSpeed = 0 - TempSpeed; //creates new variable, 0 is backwards regular speed
    }
    SpeedA = SpeedA+TempSpeed;

    while (SpeedA > 0)
    {
      DrawGenerated(GraphicsBufferA);
      SpeedA--;  //decf SpeedA
    }
  }//end if()


  if (FeedBGenerating == true && QuickFeeds[FeedBSelQuick].ControlState == 0) 
  {
    float TempSpeed = QuickFeeds[FeedBSelQuick].Speed;
    ReverseFlag = false;

    if (TempSpeed < 0) 
    {
      ReverseFlag = true; //set flag to indicate reverse order
      TempSpeed = 0 - TempSpeed; //creates new variable, 0 is backwards regular speed
    }
    SpeedB = SpeedB+TempSpeed;

    while (SpeedB > 0)
    {
      DrawGenerated(GraphicsBufferB);
      SpeedB--;
    }
  }//end if()

  //now The MixedBuffer is all updated for this frame, go ahead and send it out using the selected method
  if (CommunicationConnected == true)  SendData();  //sends the data packet

if(HandleMIDICC == true) HandleControlChange();
if(HandleMIDINO == true) HandleNoteOn();

  //=========================== START Pixel Preview Display ==========================================
  stroke(255);
  fill(0);
  strokeWeight(2);
  rect(5, 5, 260, 240);//FeedA BG
  rect(535, 5, 260, 240); //FeedB BG

  //============== MIXED PREVIEW or Full size Preview PANE =======================
  int x = 0;
  if (DisplayPreview == true)
  {
    stroke(255, 0, 0);  
    rect(275, 10, 250, 230); //output
    image(PreviewBuffer, 275, 10, 250, 230); //expands PGraphics array to larger size

    textSize(20);
    fill(0);
    text(QuickFeeds[DisplayThumbnail].UserID, 290, 230);
    fill(255);
    text(QuickFeeds[DisplayThumbnail].UserID, 288, 228);
  }
  else
  {
    stroke(128);
    strokeWeight(1);
    rect(270, 5, 260, 240); //output
    x = 0;
    for (int i=0; i != MaxPixels;i++)
    {
       if (Matrix.matrixPixelDataType < 7)  fill(MixedBuffer[x], MixedBuffer[x+1], MixedBuffer[x+2]);  //Use full color for RGB and RGBW
	   else    fill(MixedBuffer[x+(Matrix.matrixPixelDataType-7)]); //use only the selected color channel to display as grey scale
       
      MixedPixels[i].display();
      x = x+3;
    }
  }
  //============== FEED A PREVIEW PANE =======================
  stroke(128);
  strokeWeight(1);
  x = 0;
  for (int i=0; i != MaxPixels;i++)
  {
    if (Matrix.matrixPixelDataType < 7) fill(BufferA[x], BufferA[x+1], BufferA[x+2]); //Use full color for RGB and RGBW
    else   fill(BufferA[x+(Matrix.matrixPixelDataType-7)]); //use only the selected color channel to display as grey scale
    
    FeedAPixels[i].display();
    x = x+3;
  } 
  //============== FEED B PREVIEW PANE =======================
  x = 0;
  for (int i=0; i != MaxPixels;i++)
  {
    if (Matrix.matrixPixelDataType < 7)  fill(BufferB[x], BufferB[x+1], BufferB[x+2]); //Use full color for RGB and RGBW
    else   fill(BufferB[x+(Matrix.matrixPixelDataType-7)]); //use only the selected color channel to display as grey scale

    FeedBPixels[i].display();
    x = x+3;
  } 
  noStroke();

  //monitors if the user altered the screen size by dragging the window larger, and handles if resized
  if (PrevWidth != width || PrevHeight != height)
  {
    println("Window Resized to: "+width+" : "+height);    
    PrevHeight = height;  //used to watch if the grid window's size is changed
    PrevWidth = width;

    SF = (float)width / 800;
    UpdateWorkspace = true;   
    OpenMenuID = 0; //close all menus
    setup();
	
	//makes generated not error when resizing, restarts them
	FrameFirstRunA = true; 
  FrameFirstRunB = true; 
	
  }
  
  
   fill(255);
if(IntensityValueA != 1) text(int(IntensityValueA*100)+"%", 235, 240);
if(IntensityValueB != 1) text(int(IntensityValueB*100)+"%", 540, 240);
  
  
  /*
  		try {
		image(captureDSObj.updateImage(), 0, 0, MatrixWidth, MatrixHeight);
	
		}
		catch(Exception e)
		{
			println("No DShow capture avaialable.");
		} 
	*/	
}//end draw



void RedrawSpeeds()
{
  //Easiest to make a seperate function for this
           //Redraws the Speed Value next to the slider without refreshing the whole workspace 
          textSize(14);    
          fill(cBackgroundColor);
          noStroke();
          rect(CommonSliders[6].xpos-30, CommonSliders[6].ypos, 25, CommonSliders[6].slHeight);
          rect(CommonSliders[7].xpos-30, CommonSliders[7].ypos, 25, CommonSliders[7].slHeight);
          fill(cMenuFontColor);
          text(nf(QuickFeeds[FeedASelQuick].Speed, 0, 1), CommonSliders[6].xpos-30, CommonSliders[6].ypos+CommonSliders[6].slHeight);
          text(nf(QuickFeeds[FeedBSelQuick].Speed, 0, 1), CommonSliders[7].xpos-30, CommonSliders[7].ypos+CommonSliders[7].slHeight);  
}
